#######################################################################################################
#                                            BGSketchup Library                                       #
#######################################################################################################

# Some functions for BGSketchup plugins

module BGSketchup_Library
	#Required libraries
		require "sketchup.rb"
		require "extensions.rb"
	#Extension data
		BGSketchup_Library_extension = SketchupExtension.new "BGSketchup_Library", "BGSketchup_Library/Library_Main"
		BGSketchup_Library_extension.version = 'v2.5.6'
		BGSketchup_Library_extension.copyright = 'BGSketchup, November 2014'
		BGSketchup_Library_extension.creator = 'BGSketchup (Inteloide)'
		BGSketchup_Library_extension.description = "Library of functions for BGSketchup plugins"
		Sketchup.register_extension(BGSketchup_Library_extension, true)
end

=begin
	Correction jQuery :
		Supprimer ligne 3041, le return jQuery.nodeName( elem, "iframe" ) ?... et les lignes après
 
 Version history :
 2.5.6 (07/06/2015):
		Optimized :	Allow to have translation number not continous.
		
 2.5.5 (23/05/2015):
		Optimized :	Improve debug mode by creating procedure bgSketchup_debug_mode
		
 2.5.4 (10/05/2015) :
		Corrected :	return carriage error prevention in bgSketchup_to_java_for_HTML
		
 2.5.3 (06/05/2015) :
		Optimized :	Try to reduce error possibility on javascript code (setTimeout)
		
 2.5.2 (03/05/2015) :
		Optimized :	Now email is mandatory to send a error repot, in order to look for more information.
		
 2.5.1 (19/04/2015) :
		Corrected :	Preventing errors for statistics on MAC
 
 2.5.0 (12/04/2015) :
		Added :		Translation through excel file system
		Optimized :	Update manager for MAC
		Optimized :	Change update manager menu name
		
 2.4.1 (04/04/2015) :
		Optimized :	Additionnal message with beta tester subscription (due to new email validation procedure)
 
 2.4.0 (31/03/2015):
		Added : 	BGSketchup_Library version in stats
		Corrected :	remove wrong prompt after beta tester subscribe
		
 2.3.2 (26/03/2015):
		Corrected :	Issue with jQuery on Comments plugins
		
 2.3.1 (22/03/2015):
		Corrected :	Now show real error message in error window
		
 2.3.0 (21/03/2015):
		Added :		New javascript error report
		
 2.2.1 (19/03/2015) : 
		Corrected  : Now statistics work again (change temporary iframe name)
		
 2.2.0 (16/03/2015) : 
		Added :		New error message
		Corrected :	Architecture conversion system now use user preferences
		
 2.1.0 (22/02/2015) : (not official)
		Added : 	Debug mode
 
 2.0.11 (08/02/2015) :
		Corrected : change stats iframe name to avoid crash in SU8.
 
 2.0.10 (06/02/2015):
		Corrected :	avoid some errors & warnings in SU<2013
 
 2.0.9 (30/01/2015):
		Added :		Function to show length in fraction of inch
		Corrected : MAC users should appear again in stats

 2.0.8 (07/01/2015) :
		Added : picture in background of updater
		Corrected : prevent from error if webdialog is not active
		Optimized : better javascript report (browser version, line splits)
		Optimized : better prompt message after activation.
		
 2.0.7 (16/11/2014) :
		Add prompt after updating (a) plugin(s) to ask to restart.
		Close updater window after updating one or all plugins.
		Now download plugin using file + version from website.
		Updater lists also plugins not installed.
		Add beta tester request to plugins
		Add function for real temporary folder
		
 2.0.6 (15/11/2014):
		Add SU version in javascript errors.
		Prevent from errors for statistics in BGSketchup_Comments plugin
		Change jQuery version to 1.11.1
		
 2.0.5 (13/11/2014) :
		Status bar on updater
		
 2.0.4 (12/11/2014) :
		Show also plateform in javscript errors
 
 2.0.4 (11/11/2014) :
		Attempt (2) to catch statistics for MAC users : hide the iframe
		
 2.0.3 (11/11/2014) :
		Attempt to catch statistics for MAC users
		
 2.0.2 (11/11/2014):
		Add text to show plugin installation progress
		Remove 'ok' alert when a javascript bug appear in updater
		
 2.0.1 (11/11/2014) :
		Change plugin update download to BGSketchup_Library folder
		
 2.0.0 (09/11/2014) :
		Added : Plugin update manager
		New icon for debugging
		Include jscolor javascript plugin (color picker)
		Optimized : change extension search to upper case
		
 1.5.2 (08/11/2014) :
		Simplify some code
		Add activation html window
 
 1.5.1 (31/10/2014) :
		Try to improve javascript error report
		
 1.5.0 (30/10/2014) :
		Library is now an extension
		
 1.4.0 :
	21/10/2014: Improve bgSketchup_to_java fucntion for return to line issue
	21/10/2014: Added function bgSketchup_to_java_for_HTML
 1.3.0 :
	20/10/2014: Added beta tester plugin function
 1.2.0 :
	19/10/2014:	Added common toolbar possibility
 1.1.2 :
	14/10/2014: Added function to get library version in string format
 1.1.1 : 
	13/10/2014:	Correct error un UTF8 conversion (for nil strings)
 1.1.0 :
	05/10/2014: Change temporary folder to plugin folder if possible.

 1.0.0 INITIAL OFFICIAL RELEASE :
	28/09/2014:	Creation of an independant library
	03/09/2014:	Corrected issue on identifier
	31/08/2014:	Added identifier function (for statistics)
	30/08/2014: Added function to send stats to server
	24/03/2014:	Added function to find plugin folder (Thx Aerilius)
				Change global variable by moduel variables
	16/03/2014: Deleted .chr code in lines 44 & 66 to avoid errors in SU8
	19/02/2014: Change some code to avoid error on SU 2013, wrap code in module to avoid errors.
	19/01/2014: Added new function to retrieve component path with relative option : "bgSketchup_chemin_composant"
	06/01/2014: Added function for ascii/unicode strings
 	01/01/2014: Correct error in BGSketchup_retrouve_lien_absolu
=end