module BGSketchup_Library
	self::DIR = File.dirname(__FILE__)
	@@BGSketchup_menu=nil
	@@BGSketchup_toolbar=nil
	@@BGSketchup_code_js=""
	@@BGSketchup_debug_mode=false
	
	@@BGSketchup_version=BGSketchup_Library_extension.version
	Sketchup::require 'BGSketchup_Library/Library_Activation'
	extend BGSketchup_Library
	require 'sketchup.rb'
    require 'extensions.rb'
	
	#Version
	def bgSketchup_version_library
		v=BGSketchup_Library_extension.version[1..BGSketchup_Library_extension.version.length-1].split('.')
		return v[0].to_i*10000+v[1].to_i*100+v[2].to_i
	end
	def bgSketchup_version_library_string(version=nil)
		return BGSketchup_Library_extension.version if version==nil
		#version=@@BGSketchup_version if version==nil
		v_min=version%100
		v_int=((version%10000)-v_min)/100
		v_maj=(version-v_int*100-v_min)/10000
		return v_maj.to_i.to_s+"."+v_int.to_i.to_s+"."+v_min.to_i.to_s
	end
	def bgSketchup_debug_mode
		return @@BGSketchup_debug_mode
	end
	
	#Menu et toolbar
	def BGSketchup_Ajouter_Submenu(menu)
		if @@BGSketchup_menu!=nil then
		  index=@@BGSketchup_menu.index(menu)
		  if index==nil then #on ne le trouve pas
			sm=UI.menu("Plugins").add_submenu(menu)
			@@BGSketchup_menu_nb+=1
			@@BGSketchup_menu[@@BGSketchup_menu_nb]=menu
			@@BGSketchup_menu_lien[@@BGSketchup_menu_nb]=sm
		  else  #il existe déjà
			sm=@@BGSketchup_menu_lien[@@BGSketchup_menu.index(menu)]
		  end
		  
		else #rien n'existe
			sm= UI.menu("Plugins").add_submenu(menu)
			@@BGSketchup_menu=[]
			@@BGSketchup_menu_lien=[]
			@@BGSketchup_menu_nb=1
			@@BGSketchup_menu[@@BGSketchup_menu_nb]=menu
			@@BGSketchup_menu_lien[@@BGSketchup_menu_nb]=sm
		end
		return sm
	end
	def bgSketchup_creer_toolbar(nom_commande, fonction, small_icon, large_icon, tool_tip="", status_bar_text="",menu_text="")
		if @@BGSketchup_toolbar==nil then
			#Creation de la toolbar
			@@BGSketchup_toolbar = UI::Toolbar.new "BGSketchup"
		end
		cmd = UI::Command.new(nom_commande) { eval(fonction) }
		cmd.small_icon = File.join("..",small_icon)
		cmd.large_icon = File.join("..",large_icon)
		cmd.tooltip = tool_tip
		cmd.status_bar_text = status_bar_text
		cmd.menu_text = menu_text
		@@BGSketchup_toolbar = @@BGSketchup_toolbar.add_item cmd
		
	end

	#Liens relatifs/absolu
	def BGSketchup_creer_lien_relatif( fichier_destination, fichier_origine) # retourne un lien relatif de "fichier_destination" depuis "fichier_origine"
		#Convention:
		# ../toto.skp = on remonte d'un répertoire et on a le fichier toto.skp
		# toto.skp = on est dans le même répertoire et on a le fichier toto.skp
		# test/toto.skp = on va dans le sous répertoire "test" et on a le fichier toto.skp
		# creer_lien_relatif("c:/test/toto.skp","c:/testu/tutu/tata.skp")
		#On split :
			f_o=fichier_origine.gsub("\\","/").split("/")
			f_d=fichier_destination.gsub("\\","/").split("/")
		
		#On cherche la partie commune
			if (f_o[0]!=f_d[0] || fichier_origine==nil) then #Le premier bloc n'est pas commun !! Donc rien n'est commun
				return fichier_destination
			end
			for rep in 0..f_o.length-2 #-2 car on ne prend pas en compte le nom du fichier
				if f_o[rep]!=f_d[rep] then 	#On tient une différence, donc la partie commune va jusque rep-1
					if rep==0 then 			#Le premier bloc n'est pas commun !! Donc rien n'est commun
						return fichier_destination
					else
						#A partir de la on est plus commun : de combien de répertoire faut-il monter ?
						difference = (f_o.length-1) - rep #-1
						return "../" * difference + f_d[rep..f_d.length-1].join("/")
					end
				end
			end
			#Si on est ici c'est que tout est commum : soit on est dans le même répertoire, soit c'est un sous répertoire
			return  f_d[f_o.length-1..f_d.length-1].join("/") #=> On retourne les derniers blocs
	end
	def BGSketchup_retrouve_lien_absolu(lien,fichier_origine)	# retrouve le chemin absolu de "lien" depuis depuis "fichier_origine"
		return lien if lien==nil || fichier_origine==nil
		lien=lien.gsub("\\","/")
		fichier_origine=fichier_origine.gsub("\\","/")
		if lien[1]!=":"[0] && lien[0..1]!="//" && lien[0..1]!="\\\\" then
			#On n'est pas dans un lien vers le réseau ou vers un lecteur
			if lien.index("../")!=nil then
				#On doit remonter
				f_o=fichier_origine.split("/")
				nb=lien.scan("../").size
				if nb>fichier_origine.scan("/").size-1 then
					return nil #On remonte plus que le nombre de répertoire
				end
				return f_o[0..f_o.length-2-nb].join("/") + "/" + lien[lien.rindex("../")+3..lien.length]
			else
				#On ne doit pas remonter : On est dans le même répertoire ou on a un sous répertoire
				return File.dirname(fichier_origine) << "/" << lien
			end
		else
			#On est dans un lien vers le réseau ou vers un lecteur
			return lien
		end
	end
	def bgSketchup_chemin_composant(entity,relative=false) #Retourne le chemin en relatif
		return nil if entity==nil || entity.deleted?
		
		#On regarde le chemin actuel (par défaut le chemin relatif)
		if (entity.attribute_dictionary "BGSketchup_Composants")==nil
			if entity.is_a? Sketchup::ComponentDefinition then
				return entity.path 
			else
				return nil
			end
		else
			chemin_relatif = entity.get_attribute "BGSketchup_Composants", "Chemin"
			if relative==true then
				return chemin_relatif
			else
				if chemin_relatif!=nil then
					return BGSketchup_retrouve_lien_absolu(chemin_relatif,Sketchup.active_model.path)
				else
					return entity.path
				end
			end
		end
	end

	#Répertoire temporaire
	def bgSketchup_getTempFolder
		begin
			file_name=File.join(Sketchup.find_support_file("Plugins"),"BGSketchup_test.ini")
			f=File.new(file_name, "w")
			f.puts("test")
			f.close
			File.delete(file_name)
			return Sketchup.find_support_file("Plugins")
		rescue
			return ENV['TEMP'] || ENV['TMPDIR']
		end
	end	
	def bgSketchup_getRealTempFolder
		return ENV['TEMP'] || ENV['TMPDIR']
	end
	def bgSketchup_Temp_folder_is_plugin_folder?
		return (bgSketchup_getTempFolder==Sketchup.find_support_file("Plugins"))
	end

	#Conversion function (thanks to TIG)
	def bgSketchup_to_ascii(txt)
	  return txt.unpack("U*").map{|c|c.chr}.join if txt!=nil
	  return nil
	end
	def bgSketchup_to_unicode(txt)
	  return txt.unpack("C*").pack("U*") if txt!=nil
	  return nil
	end
	def bgSketchup_to_java(txt)
		return txt.to_s.gsub("\\","\\\\\\").gsub('"','\\\\"').gsub("'","\\\\'").gsub(13.chr+10.chr,"\\r\\n") if txt!=nil
		return nil
	end
	def bgSketchup_to_java_for_HTML(txt)
		return bgSketchup_to_java(txt.gsub(13.chr+10.chr,"<BR>").gsub(10.chr,"<BR>").gsub(13.chr,"<BR>")) if txt!=nil
		return nil
	end
	def bgSketchup_date_to_str(date)
		return date.strftime("%Y%m%d %H%M%S")
	end
	def bgSketchup_to_UTF8(txt)
		return "" if txt==nil
		begin
			txt=txt.encode("iso-8859-1").force_encoding("utf-8")
		rescue
			
			txt=txt.force_encoding("utf-8")
		end
		return txt
	end
	def bgSketchup_to_url_address(txt)
		txt=txt.to_s.gsub("'","")
		txt=txt.gsub('"','')
		txt=txt.gsub('&','')
		#txt=txt.to_s.tr("ÀÁÂÃÄÅàáâãäåĀāĂăĄąÇçĆćĈĉĊċČčÐðĎďĐđÈÉÊËèéêëĒēĔĕĖėĘęĚěĜĝĞğĠġĢģĤĥĦħÌÍÎÏìíîïĨĩĪīĬĭĮįİıĴĵĶķĸĹĺĻļĽľĿŀŁłÑñŃńŅņŇňŉŊŋÒÓÔÕÖØòóôõöøŌōŎŏŐőŔŕŖŗŘřŚśŜŝŞşŠšſŢţŤťŦŧÙÚÛÜùúûüŨũŪūŬŭŮůŰűŲųŴŵÝýÿŶŷŸŹźŻżŽž",
		#				"AAAAAAaaaaaaAaAaAaCcCcCcCcCcDdDdDdEEEEeeeeEeEeEeEeEeGgGgGgGgHhHhIIIIiiiiIiIiIiIiIiJjKkkLlLlLlLlLlNnNnNnNnnNnOOOOOOooooooOoOoOoRrRrRrSsSsSsSssTtTtTtUUUUuuuuUuUuUuUuUuUuWwYyyYyYZzZzZz")
		return txt
	end
	
	#Fonctions de conversion d'unité
	def bgSketchup_inch_in_architecture(nb_inch,precision=2**Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"])
		valeur=nb_inch.to_f
		feet=(valeur/12).to_i
		inches=(valeur-(feet*12)).to_i
		reste=valeur-feet*12-inches
		deci_s=""
		
		if precision!=0 then
			min=reste*10
			if reste!=0 then
				for p in 0..precision-1
					v=(valeur-feet*12-inches-p.to_f/precision).abs
					if v<min then
						min=v
						deci_inch=p
					end
				end
				deci_s=""
				deci_s=Rational(deci_inch.to_s+'/'+precision.to_s).to_s+'"' if deci_inch!=0
				deci_s="" if deci_inch==0
			else
				deci_s=""
			end
			
			if deci_inch==precision-1 then #On a plus près au dessus ?
				if (valeur-feet*12-(inches+1)).abs<min then
					inches+=1
					deci_s=""
					if inches==12 then
						inches==0
						feet+=1
					end
				end
			end
			
			if deci_inch==1 then  #On a plus près en dessous ?
					if (valeur-feet*12-(inches-1)).abs<min then
					inches-=1
					deci_s=""
					if inches==-1 then
						inches==0
						feet-=1
					end
				end
			end
		else #precision==0
			inches+=1 if (valeur-feet*12-(inches+1)).abs<reste
			inches-=1 if (valeur-feet*12-(inches-1)).abs<reste
			if inches==12 then inches=0;feet+=1; end
			if inches==-1 then inches=0;feet-=1; end
		end
		
		feet_s=""
		feet_s=feet.to_s+"'" if feet!=0
		inches_s=inches.to_s
		inches_s+='"' if deci_s==""
		inches_s+=' ' if (inches_s!="" && deci_s!="")
		feet_s+=' ' if (feet_s!="" && (inches_s!='' || deci_s!=''))
		return feet_s+inches_s+deci_s
		
	end

	#Fonctions d'import dans serveur statistiques
	def bgSketchup_add_stats(webdialog, extension, extra_data=nil)
		#On créé un tableau avec les données génériques
			data=[]
			data[0]=bgSketchup_get_identifier 				#identifier
			data[1]=extension.name.to_s.gsub(" ","_") 		#plugin
			data[2]=extension.version.to_s 					#plugin_version
			data[3]=Time.new.strftime("%Y-%m-%d %H:%M:%S")	#date
			data[4]=Sketchup.version_number.to_s 			#version_skp
			data[5]=Sketchup.os_language 					#langue
			data[6]=(Sketchup.is_pro?) ? "PRO" : "FREE"		#pro_make
			data[7]=(RUBY_PLATFORM=~/darwin/) ? 'platform_osx' : 'platform_win' #platform
		#On ajoute les donnees supplémentaires
			if extra_data!=nil then
				data=data.concat(extra_data)
			end
		#On envoie la requête
			js= "iframe_stats_bgSketchup = document.createElement('iframe');"
			js+="iframe_stats_bgSketchup.src= 'http://bgsketchup.esy.es/add_stats.php?"
				i=0
				for d in data
					js+="&" if i>0
					js+="d"+i.to_s+"="+d.to_s
					i+=1;
				end
				js+="&library="+BGSketchup_Library_extension.version
				js+="';"
			js+="document.body.appendChild(iframe_stats_bgSketchup);"
			js+="iframe_stats_bgSketchup.style.display = 'none';"
			#js+="setTimeout(function (){if (iframe_stats_bgSketchup!=undefined) { document.body.removeChild(iframe_stats_bgSketchup);} },5000);"
			bgSketchup_execute_script(webdialog,js)
	end
	def bgSketchup_get_identifier
		file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_identifier.ini")
		if File.exists?(file_name)==true then 	#File exist
			file = File.open(file_name, "r")
			while !file.eof?
				identifier=file.readline.gsub(10.chr,"").gsub(13.chr,"")
			end
			file.close
			return identifier.to_s
		else
			file=File.new(file_name, "w")
			while (identifier=srand)==0
			end
			file.puts(identifier.to_s)
			file.close
			return identifier.to_s
		end
	end
	
	#Beta tester
	def bgSketchup_beta_tester
		@my_dialog_beta = UI::WebDialog.new("BGSketchup beta tester", false, nil, 316, 293, 100, 200, true)
		html_path = File.join(File.dirname(__FILE__), "Html", "Beta_tester.html")
		@my_dialog_beta.set_file(html_path)
		@my_dialog_beta.set_background_color("ffffff")
		@my_dialog_beta.set_size(450,280)
		@my_dialog_beta.show
		
		@my_dialog_beta.add_action_callback("get_data") do |web_dialog,action_name|
			action_name=bgSketchup_to_UTF8(action_name)
			action_name.gsub!("²&é-è_çà","'")  if action_name!=nil
			if action_name.index("(")!=nil then
				action=action_name[0..action_name.index("(")-1]
				parameters=action_name[action.length+1..action_name.length-2]
				parameter=parameters.split(";")
				action_name=action
			end
			
			if action_name=="Send" then
				firstname=@my_dialog_beta.get_element_value("firstname")
				name=@my_dialog_beta.get_element_value("name")
				nickname=@my_dialog_beta.get_element_value("nickname")
				email=@my_dialog_beta.get_element_value("email")
				resultat=bgSketchup_to_be_beta_tester(@my_dialog_beta,firstname,name,nickname,email)
				UI.start_timer(1,false) {@my_dialog_beta.close} if resultat==true
			elsif action_name=="Exit" then
				@my_dialog_beta.close
			end
		end
	
	end
	def bgSketchup_to_be_beta_tester(webdialog,firstname,name,nickname,email,plugin="all")
		#On vérifie les entrées
			firstname=bgSketchup_to_url_address(firstname)
			name=bgSketchup_to_url_address(name)
			nickname=bgSketchup_to_url_address(nickname)
			email=bgSketchup_to_url_address(email)
			if (nickname.to_s=="") then
				UI.messagebox("Your must enter at least a nickname. Subscription cancelled")
				return nil
			end
		# On vérifie l'email
			if bgsketchup_verify_email(email)==false then
				UI.messagebox("Your email looks nok. Subscription cancelled")
				return nil
			end
		#On consolide les données
			firstname="0" if firstname.to_s==""
			name="0" if name.to_s==""
		#On envoie la requête
			js= "setTimeout(function() {ifr = document.createElement('iframe');"
			js+="ifr.src= 'http://bgsketchup.esy.es/add_beta_tester.php?"
			js+= "d1='+encodeURI("+'"'+firstname.to_s+'"'+")+'"
			js+="&d2='+encodeURI("+'"'+name.to_s+'"'+")+'"
			js+="&d3='+encodeURI("+'"'+nickname.to_s+'"'+")+'"
			js+="&d4='+encodeURI("+'"'+email.to_s+'"'+")+'"
			js+="&d5='+encodeURI("+'"'+plugin.to_s+'"'+")+'"
			js+="';"
			js+="document.body.appendChild(ifr);"
			js+="ifr.style.display = 'none';"
			js+="},100);"
			#js+="setTimeout(function() {document.body.removeChild(ifr);},1200);"
			bgSketchup_execute_script(webdialog,js)
			UI.messagebox("Thank you ! Please check your email box to confirm your email address.")
			return true
	end
	def bgsketchup_verify_email(email)
		return false if email==nil
		return false if email.index(" ")!=nil
		return false if email.index("@")==nil
		return false if email.index("@")==0
		return true
	end
	
	#Gestion des erreurs
	def bgSketchup_execute_script(webdialog, code, extra=nil) # exécute un code en enregistrant le code à exécuter
		return nil if webdialog==nil
		@@BGSketchup_code_js=code
		webdialog.execute_script(code)
	end
	def bgSketchup_erreur_script2OLD (parameters) #Affiche l'erreur
		puts "erreur"
		text ="!! JAVASCRIPT ERROR DETECTED !!\n\n";
		text+="Please send email to bg.sketchup@gmail.com with copy of text in this window and a brief description of how it happens.\n\n";
		text+="message = "+parameters[0].to_s+"\n\n"
		text+="line = "+parameters[1].to_s+"\n\n"
		text+="file = "+parameters[2].to_s+"\n\n"
		if ( RUBY_PLATFORM =~ /darwin/i ) == nil then
			text+="Plateform = windows\n"
		else
			text+="Plateform = MAC\n"
		end
		text+="Sketchup version = "+Sketchup.version_number.to_s+"\n"
		text+="Plugin version = "+parameters[3].to_s+"\n" if (parameters[3]!=nil)
		text+="Browser version = "+parameters[4].to_s+"\n" if (parameters[4]!=nil)
		text+="\n"
		text+="Code in error =\n"
		ligne=@@BGSketchup_code_js.split(13.chr)[parameters[1].to_i-1]
		text+=ligne.to_s+"\n\n"
		UI.messagebox(text,MB_MULTILINE)
	end
	def bgSketchup_erreur_script(error_parameters, plugin_name='') #Affiche l'erreur
		code=@@BGSketchup_code_js.split(13.chr)[error_parameters[1].to_i-1].to_s
		@my_dialog_error = UI::WebDialog.new("BGSketchup error report", false, "BGSKetchup_error_report", 316, 293, 100, 200, true)
		html_path = File.join(File.dirname(__FILE__), "Html", "Error.html")
		@my_dialog_error.set_file(html_path)
		@my_dialog_error.set_size(600,550)
		@my_dialog_error.show
		
		@my_dialog_error.add_action_callback("get_data") do |web_dialog,action_name|
			action_name=bgSketchup_to_UTF8(action_name)
			action_name.gsub!("²&é-è_çà","'")  if action_name!=nil
			if action_name.index("(")!=nil then
				action=action_name[0..action_name.index("(")-1]
				parameters=action_name[action.length+1..action_name.length-2]
				parameter=parameters.split(";")
				action_name=action
			end
			
			if action_name=="start" then
				js ='document.getElementById("pluginname").innerHTML="'+plugin_name.to_s+'";'
				js ='document.getElementById("main_description").innerHTML="'+error_parameters[0].to_s+'";'
				js+='document.getElementsByName("error_plugin_name")[0].value="'+plugin_name.to_s+'";'
				js+='document.getElementsByName("error_message")[0].value="'+error_parameters[0].to_s+'";'
				js+='document.getElementsByName("error_line")[0].value="'+error_parameters[1].to_s+'";'
				js+='document.getElementsByName("error_file")[0].value="'+error_parameters[2].to_s+'";'
				js+='document.getElementsByName("error_platform")[0].value="Windows";' if ( RUBY_PLATFORM =~ /darwin/i ) == nil
				js+='document.getElementsByName("error_platform")[0].value="Mac";' if ( RUBY_PLATFORM =~ /darwin/i ) != nil
				js+='document.getElementsByName("error_SketchUp_version")[0].value="'+Sketchup.version_number.to_s+'";'
				js+='document.getElementsByName("error_plugin_version")[0].value="'+error_parameters[3].to_s+'";' if (error_parameters[3]!=nil)
				js+='document.getElementsByName("error_library_version")[0].value="'+BGSketchup_Library_extension.version.to_s+'";'
				js+='document.getElementsByName("error_Browser_version")[0].value="'+error_parameters[4].to_s+'";' if (error_parameters[4]!=nil)
				js+='document.getElementsByName("error_language")[0].value="'+Sketchup.os_language.to_s+'";'
				
				for c in 0..code.length-1
					ch=bgSketchup_to_java(code[c].gsub("'","&quote;"))
					js+="document.getElementsByName('error_code')[0].value+='"+ch+"';"
				end
				
				@my_dialog_error.execute_script(js)
				
			elsif action_name=="details" then
				text ="message = "+error_parameters[0].to_s+"\n\n"
				text+="line = "+error_parameters[1].to_s+"\n\n"
				text+="file = "+error_parameters[2].to_s+"\n\n"
				if ( RUBY_PLATFORM =~ /darwin/i ) == nil then
					text+="Plateform = windows\n"
				else
					text+="Plateform = MAC\n"
				end
				text+="Sketchup version = "+Sketchup.version_number.to_s+"\n"
				text+="Plugin name = "+plugin_name.to_s+"\n"
				text+="Plugin version = "+error_parameters[3].to_s+"\n" if (error_parameters[3]!=nil)
				text+="Library version = "+BGSketchup_Library_extension.version.to_s+"\n"
				text+="Browser version = "+error_parameters[4].to_s+"\n" if (error_parameters[4]!=nil)
				text+="\n"
				text+="Code in error =\n"
				ligne=code
				text+=ligne.to_s+"\n\n"
				UI.messagebox(text,MB_MULTILINE)
				
			elsif  action_name=="mail" then
				js='test();'
				@my_dialog_error.execute_script(js)
				
			elsif  action_name=="exit" then
				js='test();'
				@my_dialog_error.close
			end
		end
	end
	def bgSketchup_debug_mode
		@@BGSketchup_debug_mode=!@@BGSketchup_debug_mode
		Sketchup.send_action(CMD_RUBY_CONSOLE) if @@BGSketchup_debug_mode
		bgSketchup_save_options_library
	end
	def bgSketchup_save_options_library
		file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_Library.ini")
		File.delete(file_name) if File.exists?(file_name)
		file=File.new(file_name, "w")
		file.puts("BGSketchup_debug_mode")
		file.puts(@@BGSketchup_debug_mode)
		file.close
	end

	def bgSketchup_load_options_library
		file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_Library.ini")
		if File.exists?(file_name)==true then 	#File exist
			file = File.open(file_name, "r")
			while !file.eof?
				option_name=file.readline.gsub(10.chr,"").gsub(13.chr,"")
				option_value=file.readline.gsub(10.chr,"").gsub(13.chr,"")

				@@BGSketchup_debug_mode=(option_value=="true")  if option_name=="BGSketchup_debug_mode"
			end
			file.close
		end
		Sketchup.send_action(CMD_RUBY_CONSOLE) if @@BGSketchup_debug_mode
	end
	
	#Mises à jour
	def bgSketchup_verifier_maj(webdialog,extension=nil)
	
		js='bgsketchup_plugins_version("'+extension.name+'");'
		webdialog.execute_script(js)
		
		#On envoie la requête
			js= "var iframe_maj_bgSketchup = document.createElement('iframe');"
			js+="iframe_maj_bgSketchup.src= 'http://bgsketchup.esy.es/check_version.php?"
			js+=extension.name
				js+="';"
			js+="document.body.appendChild(iframe_maj_bgSketchup);"
			js+="iframe_maj_bgSketchup.style.display = 'none';"
			js+="setTimeout(function (){document.body.removeChild(iframe_maj_bgSketchup);},5000);"
			webdialog.execute_script(js)
	end
	def bgSketchup_update_manager
		@my_dialog_update = UI::WebDialog.new("BGSketchup update manager", false, nil, 316, 293, 100, 200, true)
		html_path = File.join(File.dirname(__FILE__), "Html", "Update.html")
		@my_dialog_update.set_file(html_path)
		@my_dialog_update.set_background_color("ffffff")
		@my_dialog_update.set_size(750,390)
		@my_dialog_update.show
		
		@my_dialog_update.add_action_callback("get_data") do |web_dialog,action_name|
			action_name=bgSketchup_to_UTF8(action_name)
			action_name.gsub!("²&é-è_çà","'")  if action_name!=nil
			if action_name.index("(")!=nil then
				action=action_name[0..action_name.index("(")-1]
				parameters=action_name[action.length+1..action_name.length-2]
				parameter=parameters.split(";")
				action_name=action
			end
			
			if action_name=="start" then
				bgSketchup_execute_script(@my_dialog_update,"plugin_version='"+BGSketchup_Library_extension.version.to_s+"';")
				bgSketchup_execute_script(@my_dialog_update,"lister_plugins_available();")
				
			elsif action_name=="liste_plugins" then
				for extension_web in parameter
					ext=extension_web.split(",")
					name=ext[0]
					#On cherche l'extension dans Sketchup
					trouve=false
					for extension in Sketchup.extensions
						if extension.name==name then
							version=extension.version
							trouve=true
							break
						end
					end
					version="NA" if !(trouve)
					bgSketchup_execute_script(@my_dialog_update,"ajoute_extension('"+name.to_s+"','"+version.to_s+"','"+ext[1]+"');")
						
				end
			
			elsif action_name=="update_all" then
				bgSketchup_update_barre_etat("Update in progress...",@my_dialog_update)
				UI.start_timer(0.5,false) {
					resultat=true
					for extension in Sketchup.extensions
						if extension.name[0..10]=="BGSketchup_" then
							resultat=resultat and bgSketchup_update_plugin(extension.name)
						end
					end
					bgSketchup_execute_script(@my_dialog_update,"vide_le_tableau();callRuby('start');")
					if resultat==true then
						bgSketchup_update_barre_etat("Update of plugins done.",@my_dialog_update) 
						UI.messagebox "Update of plugins done. Please close and restart Sketchup to validate installation."
					else
						bgSketchup_update_barre_etat("",@my_dialog_update) 
						UI.messagebox("Errors in update of some plugins : "+resultat.to_s) 
					end
					@my_dialog_update.close
				}
				
			elsif action_name=="update" then
				bgSketchup_update_barre_etat("Update in progress...",@my_dialog_update)
				@bgSketchupTimerId=UI.start_timer(0.5,false) {
					UI.stop_timer(@bgSketchupTimerId)
					resultat=bgSketchup_update_plugin(parameter[0],parameter[1])
					if resultat==true then
						bgSketchup_update_barre_etat("Update of "+parameters+" done.",@my_dialog_update) 
						UI.messagebox "Update of plugin done. Please close and restart Sketchup to validate installation."
					else
						bgSketchup_update_barre_etat("",@my_dialog_update) 
						UI.messagebox("Error in update of "+parameter[0].to_s+" : "+resultat.to_s)
					end
					@my_dialog_update.close if resultat==true
				}
			elsif action_name=="beta_tester" then
				bgSketchup_beta_tester
				
			elsif action_name=="exit" then
				@my_dialog_update.close
				
			elsif action_name=="bgSketchup_erreur_script" then
				bgSketchup_erreur_script(parameter)
			end
			
		end
	end
	def bgSketchup_update_plugin(plugin_name,version)
		if Sketchup.version.split(".")[0].to_i>13 then
			#On télécharge le fichier
				chemin=File.join(bgSketchup_getTempFolder,"BGSketchup_Library")

				require 'open-uri'
				fichier=File.join(chemin,plugin_name+" "+version+'.rbz')
				url='http://bgsketchup.esy.es/'+plugin_name+'.rbz'

				error=false
				begin
					newf = File.open(fichier,'wb')
						open(url){ |f| 
							f.length
							if f.length>500 then
								newf.write(f.read)
							else
								error=true
							end
						}
					newf.close
				rescue
					error=true
				end
			
			if !error then
				#On installe
					begin
						Sketchup.install_from_archive(fichier)
						return true
					rescue Interrupt => error
						return "User said 'no'"
					rescue Exception => error
						return "Error during unzip"
					end
					
				#On demande si on veut redémarrer
				
			else
				return "Error while downloading plugin"
			end
			
		else
			return "This feature is not available on Sketchup version ealier than 2014."
		end
	end
	def bgSketchup_update_barre_etat(text,dialog)
		bgSketchup_execute_script(dialog,"document.getElementById('barre_etat').innerHTML='"+bgSketchup_to_java_for_HTML(text.to_s)+"';")
	end
	
	#Gestion des traductions
	def bgSketchup_load_translations_table(file_name)
		ligne=0
		translations_table=[]
		if File.exists?(file_name)==true then 	#File exist
			file = File.open(file_name, "r")
			while !file.eof?
				line= file.readline.encode('UTF-8').gsub(10.chr,"").gsub(13.chr,"").split(9.chr) #encode('UTF-8', 'binary', invalid: :replace, undef: :replace, replace: '')
				translations_table.push line
			end
		end
		file.close
		return translations_table
	end
	def bgSketchup_load_translations(category, language_code, file_name)
		#Load the file
			translations_table=bgSketchup_load_translations_table(file_name)
		#Found language column
			colonne=translations_table[0].index(language_code)
			colonne=1 if colonne==nil #Language doesn't exist : show english
		#Load translated text
			resultat=[]
			for line in 2..translations_table.length-1
				#Look for category that's start by category
				if translations_table[line][0][0..category.length-1]==category then
					resultat.push [translations_table[line][colonne],translations_table[line][0]]
				end
			end
		#Return result
			return resultat
	end
	def bgSketchup_load_available_languages(file_name)
		#Load the file
			translations_table=bgSketchup_load_translations_table(file_name)
		#List languages
			availableLanguages=translations_table[0][1..-1]
			availableLanguagesName=translations_table[1][1..-1]
		#Return result
			return [availableLanguages,availableLanguagesName]
	end
	
	#Ajout menu Library
	unless file_loaded?( __FILE__ )
		#Load options
			bgSketchup_load_options_library
			
		#Update manager
			menu=BGSketchup_Ajouter_Submenu("BGSketchup")
			menu.add_item("Update manager") { bgSketchup_update_manager }
			item=menu.add_item("Debug mode") { bgSketchup_debug_mode }
			status = menu.set_validation_proc(item)  { 
				if @@BGSketchup_debug_mode
					MF_CHECKED
				else
					MF_UNCHECKED
				end}
			menu.add_separator
	end
end